function doSplashStartupLoop()
{
  try
  {
    EnsureServicesReady();
    window.openDialog("chrome://pcenv/content/pcenv.xul", "mainWindow",
                      "chrome=yes,dialog=no");
    window.close();
    return;
  }
  catch (e)
  {
    if (window.failureCount == null)
      window.failureCount = 1;
    else
    {
      window.failureCount++;
      if (window.failureCount > 30)
      {
        if (!confirm("PCEnv has been unable to contact the CellML CORBA " +
                     "Server, after repeated tries. Would you like to keep " +
                     "trying? (Error was " + e + ")"))
        {
          window.close();
          return;
        }
        else
          window.failureCount = 0;
      }
    }
    setTimeout(doSplashStartupLoop, 1000);
  }
}

function EnsureServicesReady()
{
  // Get the preparer ready...
  // Components.classes["@cellml.org/cellml-preparer;1"].
  //  createInstance(Components.interfaces.nsISupports);

  // Get the CellML context service...
  if (window.context == null)
  {
    window.context = 
      Components.classes["@cellml.org/cellml-context;1"].
      getService(Components.interfaces.cellml_context_ICellMLContext);
  }

  // Get the RDF Service...
  if (window.rdfservice == null)
  {
    window.rdfservice =
      Components.classes["@mozilla.org/rdf/rdf-service;1"].
      getService(Components.interfaces.nsIRDFService);
  }

  // Get the RDF container utilities...
  if (window.rdfcu == null)
  {
    window.rdfcu =
      Components.classes["@mozilla.org/rdf/container-utils;1"].
      getService(Components.interfaces.nsIRDFContainerUtils);
  }

  // Get the module manager...
  var moduleManager = window.context.moduleManager;

  // Get the CellML Code Generation Service...
  window.ccgs = moduleManager.findModuleByName("CCCGS", "0.0");
  if (window.ccgs != null)
  {
    window.ccgs =
      window.ccgs.QueryInterface(Components.interfaces.
                                 cellml_services_ICGenerator);
  }
  
  // Get the CellML Integration Service...
  window.cis = moduleManager.findModuleByName("CIS", "0.0");
  if (window.cis != null)
  {
    window.cis =
      window.cis.QueryInterface(Components.interfaces.
                                cellml_services_ICellMLIntegrationService);
  }
}

function StartMainWindow()
{
  EnsureServicesReady();
}

function StopMainWindow()
{
  // This is needed to stop leaks (this is presumably a Mozilla bug, because
  //   window should get garbage collected, but I haven't been able to narrow it
  //   down yet).
  window.context = null;
}

function Status(x)
{
  document.getElementById("statusbar").setAttribute("label", x);
}
