function getModelMetadata(model)
{
  try
  {
    var sd = model.getRDFRepresentation("http://www.cellml.org/RDFXML/string").
      QueryInterface(Components.interfaces.
                     cellml_api_IRDFXMLStringRepresentation).serialisedData;
    
    // Put it into the Mozilla RDF implementation...
    var p = Components.classes["@mozilla.org/rdf/xml-parser;1"].
      createInstance(Components.interfaces.nsIRDFXMLParser);
    var mds = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].
      createInstance(Components.interfaces.nsIRDFDataSource);
    var modelURI = model.base_uri.asText;
    var uri = Components.classes["@mozilla.org/network/standard-url;1"].
      createInstance(Components.interfaces.nsIURI);
    uri.spec = modelURI;
    p.parseString(mds, uri, sd);
    return mds;
  }
  catch (e)
  {
    alert("There was a problem getting the metadata: " + e);
    return null;
  }
}

function setModelMetadata(model, datasource)
{
  // Firstly serialise the RDF into a mini-document...
  var xs = Components.classes["@mozilla.org/rdf/xml-serializer;1"].
    createInstance(Components.interfaces.nsIRDFXMLSerializer);
  xs.QueryInterface(Components.interfaces.nsIRDFXMLSource).init(datasource);
  var outputStream = {
    data: "",
    close : function(){},
    flush : function(){},
    write : function (buffer,count){
      this.data += buffer;
      return count;
    },
    writeFrom : function (stream,count){},
    isNonBlocking: false
  }
  xs.Serialize(outputStream);

  model.getRDFRepresentation("http://www.cellml.org/RDFXML/string").
    QueryInterface(Components.interfaces.
                   cellml_api_IRDFXMLStringRepresentation).serialisedData =
        outputStream.data;
}
