var main_thread = Components.classes["@mozilla.org/thread-manager;1"].
  getService(Components.interfaces.nsIThreadManager).mainThread;

var thread_utilities = Components.classes["@cellml.org/thread-utilities;1"].
  getService(Components.interfaces.nsIThreadUtilities);

var proxy_object_manager = Components.classes["@mozilla.org/xpcomproxy;1"].
  getService(Components.interfaces.nsIProxyObjectManager);

function ProxyToMain(object, iface)
{
  const PROXY_SYNC = 0x01;
  const PROXY_ALWAYS = 0x04;
  return proxy_object_manager.getProxyForObject(main_thread, iface, object,
                                                PROXY_SYNC | PROXY_ALWAYS);
}

function CreateUpdateUI(f, obj)
{
  obj.value = {
    QueryInterface: function(aIID)
    {
      if (aIID.equals(Components.interfaces.nsIRunnable) ||
          aIID.equals(Components.interfaces.nsISupports))
        return this;
      throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    run: function()
    {
      this.f();
    }
  }
  obj.value.f = f;

  return thread_utilities.createProxiedRunnable(main_thread, obj.value);
}
